package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.SitePunterBo;
import org.dromara.system.domain.vo.SitePunterVo;
import org.dromara.system.domain.SitePunter;
import org.dromara.system.mapper.SitePunterMapper;
import org.dromara.system.service.ISitePunterService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author Lion Li
 * @date 2024-10-31
 */
@RequiredArgsConstructor
@Service
public class SitePunterServiceImpl implements ISitePunterService {

    private final SitePunterMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     */
    @Override
    public SitePunterVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public TableDataInfo<SitePunterVo> queryPageList(SitePunterBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SitePunter> lqw = buildQueryWrapper(bo);
        Page<SitePunterVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public List<SitePunterVo> queryList(SitePunterBo bo) {
        LambdaQueryWrapper<SitePunter> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SitePunter> buildQueryWrapper(SitePunterBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SitePunter> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), SitePunter::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getTelnumber()), SitePunter::getTelnumber, bo.getTelnumber());
        lqw.eq(bo.getCreatedAt() != null, SitePunter::getCreatedAt, bo.getCreatedAt());
        lqw.eq(bo.getUpdatedAt() != null, SitePunter::getUpdatedAt, bo.getUpdatedAt());
        lqw.like(StringUtils.isNotBlank(bo.getPuntername()), SitePunter::getPuntername, bo.getPuntername());
        lqw.eq(StringUtils.isNotBlank(bo.getNotes()), SitePunter::getNotes, bo.getNotes());
        lqw.eq(StringUtils.isNotBlank(bo.getSite()), SitePunter::getSite, bo.getSite());
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     */
    @Override
    public Boolean insertByBo(SitePunterBo bo) {
        SitePunter add = MapstructUtils.convert(bo, SitePunter.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     */
    @Override
    public Boolean updateByBo(SitePunterBo bo) {
        SitePunter update = MapstructUtils.convert(bo, SitePunter.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SitePunter entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除【请填写功能名称】
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
